<?php

require_once(dirname(__FILE__) . '/iretailapi.php');
/**
 * Плагин
 */
error_reporting(E_ALL & ~E_NOTICE);

if (!defined('_VALID_MOS') && !defined('_JEXEC'))
    die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

if (!class_exists('vmPSPlugin')) require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');

class plgVMPaymentIRetail extends vmPSPlugin
{
    // public static $_this = false;
    // public static $flag = false;

    function __construct(& $subject, $config)
    {
        parent::__construct($subject, $config);
        $this->_loggable = true;
        // $this->tableFields = array_keys($this->getTableSQLFields());
        // $varsToPush = $this->getVarsToPush();
        // $this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
        // print_R($config);die;
        $p=json_decode($config['params'],1);
        IRetailApi::config([
          'debug'=>1,
          'power'=>$p['power'],
          'mode'=>$p['mode'],
          'log'=>$p['log'],
          'login'=>$p['login'],
          'apikey'=>$p['apikey'],
          'printmode'=>$p['printmode'],
          'notifymode'=>$p['notifymode'],
          'mailer'=>new VMIretailMailer($p['emails']),
        ]);   
    }

    public function plgVmOnUpdateOrderBEPayment($o)
    {
        // var_dump(JUri::base(),JUri::base(true),JUri::root());
      if (IRetailAPI::$power) {
        return '
<form action="'.JUri::base(true).'/index.php?option=com_virtuemart&view=plugin&type=vmpayment&name=iretail" method="post"><b>i-Retail.com</b>&nbsp;&nbsp;&nbsp;
<input type="hidden" name="order_id" value="'.(int)$o.'">
<button class="btn btn-small" name="action" value="payment">Отправить платеж</button>&nbsp;&nbsp;
<button class="btn btn-small" name="action" value="refund">Отправить возврат</button>
</form>
';
      }
    }
    public function plgVmOnSelfCallBE($type, $name, $render)
    {
              // print_R($_SERVER);  var_dump($type, $name, $render);die;
        $order_id=vRequest::getInt('order_id');
        $action=vRequest::getString('action');

        $r=isset($_SERVER['HTTP_REFERER'])?$_SERVER['HTTP_REFERER']:false;
        if ($action=='clearlog')
        {
            IRetailAPI::clearLog();
            if (!$r)
                $r=url_decode(vRequest::getString('r'));
            // JResponse::setHeader('Location',$r);
            JFactory::getApplication()->redirect($r,'Журнал очишен');
        }
        elseif ($action=='payment' || $action=='refund')
        {
          $ret=self::order2iretail($order_id,$action=='refund');
          if (!$r)
            $r=JUri::base(true).'/index.php?option=com_virtuemart&view=orders&task=edit&virtuemart_order_id='.$order_id;
          if ($ret['status']!='OK')
            JFactory::getApplication()->redirect($r,'При отправке данных на i-Retail.com возникла ошибка', 'error');
          else
            JFactory::getApplication()->redirect($r,'Данные успешно переданы на i-Retail.com', 'message');
        }
        // JResponse::setHeader('Location',$r);
        $render=false;
        jexit();
    }

    public static function order2iretail($order_id,$refund=false)
    {
      if ((int)$order_id)
      {
        $orderModel = VmModel::getModel('orders');
        $order = $orderModel->getOrder($order_id);
        $data = [
          'external_order_id' => $order['details']['BT']->virtuemart_order_id,
          'external_order_time' => gmdate('Y-m-d H:i:s',strtotime($order['details']['BT']->order_created)),//$order['details']['BT']->order_created,  //?created_on
          'date_time' => gmdate('Y-m-d H:i:s',strtotime($order['details']['BT']->order_created)),
          'type' => $refund?'refund':'payment',
          'customer_phone' => $order['details']['BT']->phone_1,
          'customer_email' => $order['details']['BT']->email,
          'card_amount' => round($order['details']['BT']->order_total,2),
          // 'cash_amount' => 0,
          // 'mc_amount' => 0,
          'purchase' => ['products' => []],
        ];
// echo '<pre>';
// var_dump(count($order['items']));die;
        foreach($order['items'] as $item) {
          $d=[
            'name'=>$item->order_item_name,
            'quantity'=>$item->product_quantity,
            'price'=>$item->product_final_price,
          ];

          if ($item->product_tax_id!==null)
            $d['vat']=number_format($item->product_tax/($item->product_final_price-$item->product_tax),2,".","");
          $data['purchase']['products'][]=$d;
          // var_dump($data['purchase']['products']);
        }

      if (round($order['details']['BT']->order_shipment+$order['details']['BT']->order_shipment_tax,2)!=0) {
        $d=[
            'name'=>'Стоимость обработки и доставки',
            'quantity'=>1,
            'price'=>round($order['details']['BT']->order_shipment+$order['details']['BT']->order_shipment_tax,2),
          ];
        if (floatval($order['details']['BT']->order_shipment_tax))
            $d['vat']=number_format($order['details']['BT']->order_shipment_tax/$order['details']['BT']->order_shipment,2,".","");
        $data['purchase']['products'][]=$d;
      }

      if (round($order['details']['BT']->order_payment+$order['details']['BT']->order_payment_tax,2)!=0) {
        $d=[
            'name'=>'Комиссия',
            'quantity'=>1,
            'price'=>round($order['details']['BT']->order_payment+$order['details']['BT']->order_payment_tax,2),
          ];
        if (floatval($order['details']['BT']->order_payment_tax))
            $d['vat']=number_format($order['details']['BT']->order_payment_tax/$order['details']['BT']->order_payment,2,".","");
        $data['purchase']['products'][]=$d;
      }

          /* ???
        foreach ($order['calc_rules'] as $rule) {
          if($rule->calc_kind!='VatTax' and $rule->calc_kind!='taxRulesBill') continue;
          $data['purchase']['products'][]=[
            'name'=>vmText::_('COM_VIRTUEMART_ORDER_PRINT_PAYMENT'),
            'quantity'=>1,
            'price'=>round($order['details']['BT']->order_payment+$order['details']['BT']->order_payment_tax,2),
          ];
          */
// var_dump($data['purchase']['products']);die;
        $ret=IRetailAPI::request($data);
        //$orderModel->updateStatusForOneOrder($order_id,['add_order_note($ret['text']);
        $orderModel->_updateOrderHist($order_id,$order['details']['BT']->order_status,false,$ret['text']);
        // админка не показывает??
        return $ret;

      }
    }


/*
    function getTableSQLFields()
    {
        $SQLfields = array(
            'id' => 'int(11) unsigned NOT NULL AUTO_INCREMENT',
            'virtuemart_order_number' => 'char(32) DEFAULT NULL',
            'virtuemart_order_id' => 'char(32) DEFAULT NULL',
            'virtuemart_paymentmethod_id' => 'char(32) DEFAULT NULL',
            'rbs_order_id' => 'char(36) DEFAULT NULL'
        );
        return $SQLfields;
    }
    */
    function plgVmOnUpdateOrderPayment($data,$old_order_status)
    {
      if (IRetailAPI::$power) {
        $order_status = $data->order_status;
        if($order_status=='C' && $old_order_status!="C")
          $this->order2iretail($data->virtuemart_order_id);
      }
    }


}

class VMIretailMailer implements IretailMailerInterface {
  use IretailMailerTrait;

  function notify($subject, $message)
  {
    // die('asdasd');
    $mailer = JFactory::getMailer();
    $config = JFactory::getConfig();
    $sender = array( 
        $config->get( 'mailfrom' ),
        $config->get( 'fromname' ) 
    );
    foreach ($this->emails as $e)
      $mailer->addRecipient($e);

    $mailer->isHtml(false);
    $mailer->setSubject($subject);
    $mailer->setBody($message);    
    $mailer->Send();
  }

}